//m3p03_04.c - Algorisme d'Euclides -
#include <stdio.h>
#include <stdlib.h>

#define DEPURACIO
#define SO_LINUX

int mcd(int,int); // Declaració de prototipus d'una funció
// Retorna un tipus int i té dos arguments, també de tipus int

int main(){
    int nN,nM; // Variables locals a la funció main()

#ifndef SO_LINUX
	system("cls"); // Entenc que si no és Linux és Finestrots
#else
    system("clear"); // Pels afinestrats és system("cls");
#endif
    // system() és una funció que executa ordres del sistema operatiu
    // Per tant, és depenent dels sistema operatiu. Una mala idea, habitualment.
    // Sempre que puguem, farem que els codis es puguin compilar a
    // diferents sistemes operatius
    printf("Introduïu dos nombres enters separats per un espai: ");
    scanf("%d %d",&nN,&nM);
    printf("\n\nmcd(%d,%d) = %d\n",nN,nM,mcd(nN,nM)); // la funció mcd es cridad amb dos paràmetres 
			//per exemple, si nN = 120 i nM = 90 es crida mcd(120,90)

    return 0;
}

// Aquesta és la implementació de la funció declarada com a prototipus
int mcd(int m,int n){ // m i n són varaibles locals a la funció
					  // Aquestes dues variables són arguments de la funció.
					  // Prenen el valor que els hi passa qui crida la funció
		// si la crida ha estat, per exemple mcd(120,90), a aquesta funció
		// m pren el valor 120 i pren el valor 90
    int r, i = 0; // Variable local a la funció

#ifdef DEPURACIO
	printf("%d) m: %d , n: %d\n",i++,m,n);
#endif
    while(n>0){
        r=m%n;
        m=n;
        n=r;
#ifdef DEPURACIO
		printf("%d) m: %d , n: %d\n",i++,m,n);
#endif
   }
#ifdef DEPURACIO
   printf("%d) m: %d , n: %d\n",i++,m,n);
#endif

   return m; // Ha de retornar un int, per a ser coherent amb la funció
}
